namespace eval ::swankFile {

proc getAbsolutePath {path} {
return [file nativename [file join [pwd] $path]]
}

proc exists {path} {
if {![file exists $path]} {
    return 0
}


set pathtype [file pathtype $path]
set isdirectory [file isdirectory $path]
set isfile [file isfile $path]
set length [file size $path]
set isreadable [file readable $path]
set iswritable [file writable $path]
set mtime [file mtime $path]
return "1 pathtype $pathtype isdirectory $isdirectory isfile $isfile length $length isreadable $isreadable iswritable $iswritable mtime $mtime"
}

proc mkdir {path} {
    file mkdir $path
}

proc renameTo {origin dest} {
    file mkdir $path
}

proc listFiles {path} {
    puts "listFiles for $path"
   set result ""
   set files [glob -nocomplain [file join $path *]]
   if {[llength $files] == ""} {
    return ""
   }
    foreach file $files {
        lappend result [file nativename $file]
    }
    puts $result
    return $result
}
proc getParent {dir} {
 puts "getParentDir $dir"
#          Returns the parent directory of dir.
 return [file nativename [file dirname $dir]]
}
# F
}

namespace eval ::fileSystemView {
#File
 proc createFileObject {dir {filename {}}} { 
          #Returns a File object constructed in dir from the given filename.
          puts "createFileObject $dir $filename"
        if {$filename == {}} {
            return [createFileObjectFromPath $dir]
          }
          set newfile [file nativename [file join $dir $filename]]
          
           return $newfile
 }

 #File
 proc createFileObjectFromPath {path} { 
#          Returns a File object constructed from the given path string.
puts "createFileObjectFromPath $path"
        return $path
}

#File 
proc createFileSystemRoot {f} { 
puts "cFSR $f"
#          Creates a new File object for f with correct behavior for a file system root directory. 
}

#File
proc createNewFolder {containingDir} {
#          Creates a new folder with a default folder name. 
    set newDir [file join $containingDir "New Folder"]
    file mkdir $newDir
    return $newDir
}

#File
proc getChild {parent fileName} {
puts "getChild $parent $fileName"
return [file join $parent $fileName]
}            

#File
proc getDefaultDirectory {} { 
puts getDefaultDir
#          Return the user's default starting directory for the file chooser.
    return [pwd]
}

# File[] 
proc getFiles {dir useFileHiding} {
puts "getFiles $dir $useFileHiding"
#          Gets the list of shown (i.e.
    set files [glob -nocomplain [file join $dir *]]
    foreach file $files {
        lappend result [file nativename [file tail $file]]
    }
    return $result
}
            
#File 
proc getHomeDirectory {} { 
puts "getHomeDir"
global env
return $env(HOME)
}            

proc getParentDirectory {dir} {
 puts "getParentDir $dir"
#          Returns the parent directory of dir.
 return [file nativename [file dirname $dir]]
}
# File[] 
proc getRoots {} { 
puts "getRoots"
#          Returns all root partitions on this system. 
return {C:}
}
#String
proc getSystemDisplayName {f} { 
puts "getSystemDisplayName $f"
#          Name of a file, directory, or folder as it would be displayed in a system file browser. 
}

# String 
proc getSystemTypeDescription {f} {
puts "getSystemTypeDesc $f"
#          Type description for a file, directory, or folder as it would be displayed in a system file browser. 
return $f
}
# boolean 
proc isComputerNode {dir} {
puts "isNode $dir"
}
            
# boolean
proc isDrive {dir} {
puts "isDrive $dir"
return false
}
            
#boolean 
proc isFileSystem {f} {
puts "isFileSystem $f"
return false
}
            
# boolean
proc isFileSystemRoot {dir} {
puts "isFileSystemRoot $dir"
return false
}
            
proc isFloppyDrive {File dir} {
puts "isFloppy $dir"
return false
}
            
#boolean
proc isHiddenFile {f} {
 puts "isHidden $f"
#          Returns whether a file is hidden or not. 
return false
}

# boolean
proc isParent {folder file} {
 puts "isParent $folder $file"
#          On Windows, a file can appear in multiple folders, other than its parent directory in the filesystem. 
return [string equals $folder [file dirname $file]]
}
# boolean
proc isRoot {f} { 
puts "isRoot $f"
#          Determines if the given file is a root in the navigatable tree(s). 

}
# Boolean
proc isTraversable {File f} {
 puts "isTraversable $f"
#          Returns true if the file (directory) can be visited. 
}
}
