package provide Tk 8.3
set tk_version 8.3
set tk_patchLevel 8.3.0
set tk_strictMotif 0
proc tkwait {args} {
   if {[llength $args] != 2} {
	error {wrong # args: should be "tkwait variable|visibility|window name"}
   }
   set mode [lindex $args 0]
    switch $mode {
	variable {
	        update
		vwait [lindex $args 1]
	}
	visibility {
           puts "tkwait $args"
        }
	window  {
           puts "tkwait $args"
        }
	default {
          error "bad option \"$mode\": must be variable, visibility, or window"
	}
   }
}

proc tk {args } {
	if {$args == "appname"} {
		return Wisk
        }
}


proc tk_getOpenFile {args} {
    
    if { [expr [llength $args] % 2] != 0} {
        error "args not multiple of two"
    }
    
    destroy .sk_filebox
    jfilechooser .sk_filebox
    foreach "argType argVal" $args {
        switch -- $argType {
            -filetypes {
                set filters [lindex $argVal 0]
                .sk_filebox filter [lindex $filters 1] [lindex $filters 0]
            }
            
            -initialdir {
                .sk_filebox configure -currentdirectory $argVal
            }
            -title {
                .sk_filebox configure -dialogtitle $argVal
            }
            -multiple {
                .sk_filebox configure -multiselectionenabled $argVal
            }
        }
    }
    
    .sk_filebox configure -visible true
    set result [.sk_filebox open]
    destroy .sk_filebox
    return $result
}

proc tk_getSaveFile {args} {
    destroy .sk_filebox
    jfilechooser .sk_filebox
     foreach "argType argVal" $args {
        switch -- $argType {
            -filetypes {
                set filters $argVal
                foreach filter $filters {
                        set description [lindex $filter 0]
                        set extensions [lindex $filter 1]
                        .sk_filebox filter $extensions $description
                    }
            }
            
            -initialdir {
                .sk_filebox configure -currentdirectory $argVal
            }
            -title {
                .sk_filebox configure -dialogtitle $argVal
            }
        }
    }
    .sk_filebox configure -visible true
    set result [.sk_filebox save duck]
    destroy .sk_filebox
    return $result
}

proc tk_chooseDirectory {args} {
    destroy .sk_filebox
    jfilechooser .sk_filebox -currentdirectory [pwd]
     foreach "argType argVal" $args {
        switch -- $argType {
             -initialdir {
                .sk_filebox configure -currentdirectory $argVal
            }
            -title {
                .sk_filebox configure -dialogtitle $argVal
            }
        }
    }
    [.sk_filebox object] setFileSelectionMode [java::field javax.swing.JFileChooser DIRECTORIES_ONLY]
    [.sk_filebox object] setVisible true
    set result [.sk_filebox open duck]
    destroy .sk_filebox
    return $result
}

proc tk_optionMenu {nm var args} {
    jcombobox $nm -variable $var
    foreach arg $args {
        $nm jadd $arg
    }
}




proc tk_chooseColor {args} {
    global tk_colorChooser
    set initialColor black
    set title ColorChooser
     foreach "argType argVal" $args {
        switch -- $argType {
             -initialcolor {
    		set initialColor $argVal
            }
            -title {
    		set title $argVal
            }
        }
    }
    set interp [java::getinterp]
    set colorString [java::call tcl.lang.TclString newInstance $initialColor]
    set curColor [java::call com.onemoonscientific.swank.SwankUtil getColor $interp $colorString]
    set newColor [java::call javax.swing.JColorChooser showDialog [. object] $title $curColor]
    if {$newColor == [java::null]} {
	return ""
    }
    set newColorName [java::call com.onemoonscientific.swank.SwankUtil parseColor $interp $newColor]
    return $newColorName
}


proc grab {args} {
    puts "grab $args"
}


proc getColumnCount {} {
    return 0
}

set tk_library resource:/com/onemoonscientific/swank/library
toplevel .
raise .
proc swank_source {args} {
	if {[llength $args] == 2} {
		uplevel #0 jacl_source [lindex $args 0] [lindex $args 1]
	} else {
		if {[string match resource:* $args]} {
			uplevel #0 jacl_source -url $args
		} else {
			uplevel #0 jacl_source $args
		}
	}
}


proc console {mode args} {
    if {$mode == "show"} {
        global tcl_prompt1
        global tcl_prompt2
        if {![winfo exists .console]} {
            tkConsoleInit
            set tcl_prompt1 >
            set tcl_prompt2 >
            tkConsolePrompt
            rename puts swkcon_tcl_puts
            rename swkcon_puts puts
        }
        wm deiconify .console
    } else {
        if {[winfo exists .console]} {
            wm withdraw .console
        }
    }
}
